/* example-start aspectframe aspectframe.c */

#include <gtk/cc/gtk.h>
   
int
main (int argc, char *argv[])
{
    GtkWindow *window;
    GtkAspectFrame *aspect_frame;
    GtkDrawingArea *drawing_area;
    gtk_init (&argc, &argv);
   
    window = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);
    window->set_title_ ("Aspect Frame");
    window->connect_ ("destroy", GTK_SIG gtk_main_quit, NULL);
    window->set_border_width_ (10);
   
    /* Create an aspect_frame and add it to our toplevel window */
   
    aspect_frame = GtkAspectFrame::_new ("2x1", /* label */
                                         0.5, /* center x */
                                         0.5, /* center y */
                                         2, /* xsize/ysize = 2 */
                                         FALSE /* ignore child's aspect */);
   
    window->add_ (aspect_frame)-> show_ ();
   
    /* Now add a child widget to the aspect frame */
   
    drawing_area = GtkDrawingArea::_new ();
   
    /* Ask for a 200x200 window, but the AspectFrame will give us a 200x100
     * window since we are forcing a 2x1 aspect ratio */
    drawing_area->set_usize_ (200, 200);
    aspect_frame->add_ (drawing_area)-> show_ ();
   
    window->show_ ();
    gtk_main ();
    return 0;
}
/* example-end */
