/* example-start buttons buttons.c */

#include <gtk/cc/gtk.h>

/* Create a new hbox with an image and a label packed into it
 * and return the box. */

GtkBox *xpm_label_box( GtkWidget *parent,
                       gchar     *xpm_filename,
                       gchar     *label_text )
{
    GtkHBox *box1;
    GdkPixmap *pixmap;
    GdkBitmap *mask;

    /* Create box for xpm and label */
    box1 = GtkHBox::_new (FALSE, 0);
    box1->set_border_width_ (2);

    /* Now on to the xpm stuff */
    pixmap = gdk_pixmap_create_from_xpm (parent->window, &mask,
					 &(parent->get_style_()->bg[GTK_STATE_NORMAL]),
					 xpm_filename);

    /* Pack the pixmap and label into the box */
    box1->pack_start_ (GtkPixmap::_new (pixmap, mask), FALSE, FALSE, 3)-> show_ ();
    box1->pack_start_ (GtkLabel::_new (label_text), FALSE, FALSE, 3)-> show_ ();

    return(box1);
}

/* Our usual callback function */
void callback( GtkWidget *widget,
               gpointer   data )
{
    g_print ("Hello again - %s was pressed\n", (char *) data);
}


int main( int   argc,
          char *argv[] )
{
    GtkWindow *window;
    GtkButton *button;
    GtkBox *box1;

    gtk_init (&argc, &argv);

    window = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);

    window->set_title_ ("Pixmap'd Buttons!");

    /* It's a good idea to do this for all windows. */
    window->connect_ ("destroy", GTK_SIG gtk_exit, NULL);
    window->connect_ ("delete_event", GTK_SIG gtk_exit, NULL);

    window->set_border_width_ (10);
    window->realize_();

    button = GtkButton::_new ();

    button->connect_ ("clicked", GTK_SIG callback, "cool button");

    /* This calls our box creating function */
    box1 = xpm_label_box(window, "info.xpm", "cool button");

    /* Pack and show all our widgets */
    button->add_ (box1)->show_ ();
    window->add_ (button)->show_ ();
    window->show_ ();

    /* Rest in gtk_main and wait for the fun to begin! */
    gtk_main ();

    return(0);
}
/* example-end */
