/* example-start entry entry.c */

#include <stdio.h>
#include <gtk/cc/gtk.h>

void enter_callback(GtkWidget *widget, GtkEntry *entry)
{
  printf("Entry contents: %s\n", entry->get_text_ ());
}

void entry_toggle_editable (GtkCheckButton *checkbutton,
				   GtkEntry *entry)
{
  entry->set_editable_ (checkbutton->active);
}

void entry_toggle_visibility (GtkCheckButton *checkbutton,
				   GtkEntry *entry)
{
  entry->set_visibility_(checkbutton->active);
}

int main (int argc, char *argv[])
{

    GtkWindow *window;
    GtkBox *vbox, *hbox;
    GtkEntry *entry;
    GtkButton *button;
    GtkCheckButton *check;

    gtk_init (&argc, &argv);

    /* create a new window */
    window = GtkWindow::_new(GTK_WINDOW_TOPLEVEL);
    window->set_usize_ (200, 100);
    window->set_title_ ("GTK Entry");
    window->connect_ ("delete_event", GTK_SIG gtk_exit, NULL);

    vbox = GtkVBox::_new (FALSE, 0);
    window->add_ (vbox)->show_ ();

    entry = GtkEntry::_new_with_max_length (50);
    entry->connect_ ("activate", GTK_SIG enter_callback, entry);
    entry->set_text_ ("hello");
    entry->append_text_ (" world");
    entry->select_region_ (0, entry->text_length);
    vbox->pack_start_ (entry, TRUE, TRUE, 0)->show_ ();

    hbox = GtkHBox::_new (FALSE, 0);
    vbox->add_ (hbox)->show_ ();
                                  
    check = GtkCheckButton::_new_with_label ("Editable");
    hbox->pack_start_ (check, TRUE, TRUE, 0);
    check->connect_ ("toggled", GTK_SIG entry_toggle_editable, entry);
    check->set_active_(TRUE);
    check->show_ ();
    
    check = GtkCheckButton::_new_with_label("Visible");
    hbox->pack_start_ (check, TRUE, TRUE, 0);
    check->connect_ ("toggled",	GTK_SIG entry_toggle_visibility, entry);
    check->set_active_ (TRUE);
    check->show_ ();
                                   
    button = GtkButton::_new_with_label ("Close");
    button->connect_object_ ("clicked", GTK_SIG gtk_exit, window);
    vbox->pack_start_ (button, TRUE, TRUE, 0);
    GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
    button->grab_default_ ();
    button->show_ ();
    
    window->show_ ();

    gtk_main();
    return(0);
}
/* example-end */
