/* example-start eventbox eventbox.c */

#include <gtk/cc/gtk.h>

int 
main (int argc, char *argv[])
{
    GtkWindow *window;
    GtkEventBox *event_box;
    GtkLabel *label;
    
    gtk_init (&argc, &argv);
    
    window = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);
    window->set_title_ ("Event Box");
    window->connect_ ("destroy", GTK_SIG gtk_exit, NULL);
    window->set_border_width_ (10);
    
    /* Create an EventBox and add it to our toplevel window */
    
    event_box = GtkEventBox::_new ();
    window->add_ (event_box)->show_ ();
    
    /* Create a long label */
    
    label = GtkLabel::_new ("Click here to quit, quit, quit, quit, quit");
    event_box->add_ (label)->show_ ();
    
    /* Clip it short. */
    label->set_usize_ (110, 20);
    
    /* And bind an action to it */
    event_box->set_events_ (GDK_BUTTON_PRESS_MASK);
    event_box->connect_ ("button_press_event", GTK_SIG gtk_exit, NULL);
    
    /* Yet one more thing you need an X window for ... */
    
    event_box->realize_ ();
    gdk_window_set_cursor (event_box->window, gdk_cursor_new (GDK_HAND1));
    
    gtk_widget_show (window);
    
    gtk_main ();
    
    return(0);
}
/* example-end */
