/* example-start filesel filesel.c */

#include <gtk/cc/gtk.h>

/* Get the selected filename and print it to the console */
void file_ok_sel (GtkWidget *w, GtkFileSelection *fs)
{
    g_print ("%s\n", fs->get_filename_ ());
}

void destroy (GtkWidget *widget, gpointer data)
{
    gtk_main_quit ();
}

int main (int argc, char *argv[])
{
    GtkFileSelection *filew;
    
    gtk_init (&argc, &argv);
    
    /* Create a new file selection widget */
    filew = GtkFileSelection::_new ("File selection");
    
    filew->connect_ ("destroy", GTK_SIG destroy, &filew);
    /* Connect the ok_button to file_ok_sel function */
    filew->ok_button->connect_ ("clicked", GTK_SIG file_ok_sel, filew );
    
    /* Connect the cancel_button to destroy the widget */
    filew->cancel_button->connect_object_ ("clicked", GTK_SIG gtk_widget_destroy, filew);
    
    /* Lets set the filename, as if this were a save dialog, and we are giving
     a default filename */
    filew->set_filename_ ("penguin.png");
    
    filew->show_ ();
    gtk_main ();
    return 0;
}
/* example-end */
