/* example-start fixed fixed.c */

#include <gtk/cc/gtk.h>

/* I'm going to be lazy and use some global variables to
 * store the position of the widget within the fixed
 * container */
gint x=50;
gint y=50;

/* This callback function moves the button to a new position
 * in the Fixed container. */
void move_button( GtkWidget *widget,
                  GtkFixed *fixed )
{
  x = (x+30)%300;
  y = (y+50)%300;
  fixed->move_ (widget, x, y); 
}

int main( int   argc,
          char *argv[] )
{
  /* GtkWidget is the storage type for widgets */
  GtkWindow *window;
  GtkFixed *fixed;
  GtkButton *button;
  gint i;

  /* Initialise GTK */
  gtk_init(&argc, &argv);
    
  /* Create a new window */
  window = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);
  window->set_title_ ("Fixed Container");

  /* Here we connect the "destroy" event to a signal handler */ 
  window->connect_ ("destroy", GTK_SIG gtk_main_quit, NULL);
 
  /* Sets the border width of the window. */
  window->set_border_width_ (10);

  /* Create a Fixed Container */
  fixed = GtkFixed::_new();
  window->add_ (fixed)->show_ ();
  
  for (i = 1 ; i <= 3 ; i++) {
    /* Creates a new button with the label "Press me" */
    button = GtkButton::_new_with_label ("Press me");
  
    /* When the button receives the "clicked" signal, it will call the
     * function move_button() passing it the Fixed Containter as its
     * argument. */
    button->connect_ ("clicked", GTK_SIG move_button, fixed);
  
    /* This packs the button into the fixed containers window. */
    fixed->put_ (button, i*50, i*50);
  
    /* The final step is to display this newly created widget. */
    button->show_ ();
  }

  /* Display the window */
  window->show_ ();
    
  /* Enter the event loop */
  gtk_main ();
    
  return(0);
}
/* example-end */
