/* example-start helloworld2 helloworld2.c */

#include <gtk/cc/gtk.h>

/* Our new improved callback.  The data passed to this function
 * is printed to stdout. */
void callback( GtkWidget *widget,
               gpointer   data )
{
    g_print ("Hello again - %s was pressed\n", (char *) data);
}

/* another callback */
void delete_event( GtkWidget *widget,
                   GdkEvent  *event,
		   gpointer   data )
{
    gtk_main_quit ();
}

int main( int   argc,
          char *argv[] )
{
    /* GtkWidget is the storage type for widgets */
    GtkWindow *window;
    GtkButton *button;
    GtkBox *box1;

    /* This is called in all GTK applications. Arguments are parsed
     * from the command line and are returned to the application. */
    gtk_init (&argc, &argv);

    /* Create a new window */
    window = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);

    /* This is a new call, this just sets the title of our
     * new window to "Hello Buttons!" */
    window->set_title_ ("Hello Buttons!");

    /* Here we just set a handler for delete_event that immediately
     * exits GTK. */
    window->connect_ ("delete_event", GTK_SIG delete_event, NULL);

    /* Sets the border width of the window. */
    window->set_border_width_ (10);

    /* We create a box to pack widgets into.  This is described in detail
     * in the "packing" section. The box is not really visible, it
     * is just used as a tool to arrange widgets. */
    box1 = GtkHBox::_new(FALSE, 0);

    /* Put the box into the main window. */
    window->add_ (box1);

    /* Creates a new button with the label "Button 1". */
    button = GtkButton::_new_with_label ("Button 1");

    /* Now when the button is clicked, we call the "callback" function
     * with a pointer to "button 1" as its argument */
    button->connect_ ("clicked", GTK_SIG callback, "button 1");

    /* Instead of gtk_container_add, we pack this button into the invisible
     * box, which has been packed into the window. */
    box1->pack_start_ (button, TRUE, TRUE, 0)->show_ ();

    /* Do these same steps again to create a second button */
    button = GtkButton::_new_with_label ("Button 2");

    /* Call the same callback function with a different argument,
     * passing a pointer to "button 2" instead. */
    button->connect_ ("clicked", GTK_SIG callback, "button 2");

    box1->pack_start_ (button, TRUE, TRUE, 0)->show_ ();

    box1->show_ ();

    window->show_ ();

    /* Rest in gtk_main and wait for the fun to begin! */
    gtk_main ();

    return(0);
}
/* example-end */
