/* example-start statusbar statusbar.c */

#include <gtk/cc/gtk.h>
#include <glib.h>

GtkStatusbar *status_bar;

void push_item (GtkWidget *widget, gpointer data)
{
  static int count = 1;
  char buff[20];

  g_snprintf(buff, 20, "Item %d", count++);
  status_bar->push_ (GPOINTER_TO_INT(data), buff);

  return;
}

void pop_item (GtkWidget *widget, gpointer data)
{
  status_bar->pop_ (GPOINTER_TO_INT(data) );
  return;
}

int main (int argc, char *argv[])
{

    GtkWindow *window;
    GtkVBox *vbox;
    GtkButton *button;

    gint context_id;

    gtk_init (&argc, &argv);

    /* create a new window */
    window = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);
    window->set_usize_ (200, 100);
    window->set_title_ ("GTK Statusbar Example");
    window->connect_ ("delete_event", GTK_SIG gtk_exit, NULL);
 
    vbox = GtkVBox::_new (FALSE, 1);
    window->add_ (vbox)->show_ ();
          
    status_bar = GtkStatusbar::_new( );      
    vbox->pack_start_ (status_bar, TRUE, TRUE, 0)->show_ ();

    context_id = status_bar->get_context_id_ ("Statusbar example");

    button = GtkButton::_new_with_label ("push item");
    button->connect_ ("clicked", GTK_SIG push_item, GINT_TO_POINTER(context_id) );
    vbox->pack_start_ (button, TRUE, TRUE, 2)->show_ ();

    button = GtkButton::_new_with_label ("pop last item");
    button->connect_ ("clicked", GTK_SIG pop_item, GINT_TO_POINTER(context_id) );
    vbox->pack_start_ (button, TRUE, TRUE, 2)->show_ ();

    /* always display the window as the last step so it all splashes on
     * the screen at once. */
    window->show_ ();

    gtk_main ();

    return 0;
}
/* example-end */
