/* example-start radiobuttons radiobuttons.c */

#include <gtk/cc/gtk.h>

void close_application( GtkWidget *widget,
                      GdkEvent  *event,
                      gpointer   data )
{
gtk_main_quit();
}

int main( int   argc,
        char *argv[] )
{
  GtkWindow *window = 0;
  GtkBox *box1;
  GtkBox *box2;
  GtkRadioButton *rbutton;
  GtkButton* button;
  GtkSeparator *separator;
  GSList *group;

  gtk_init(&argc,&argv);    
    
  window = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);

  window->connect_ ("delete_event", GTK_SIG close_application,  NULL);

  window->set_title_ ("radio buttons");
  window->set_border_width_ (0);

  box1 = GtkVBox::_new (FALSE, 0);
  window->add_ ( box1)->show_ (); 

  box2 = GtkVBox::_new (FALSE, 10);
  box2->set_border_width_ (10);
  box1->pack_start_ (box2, TRUE, TRUE, 0)->show_ ();

  rbutton = GtkRadioButton::_new_with_label (0, "button1");
  box2->pack_start_ (rbutton, TRUE, TRUE, 0)->show_ ();

  group = gtk_radio_button_group (GTK_RADIO_BUTTON (rbutton));
  rbutton = GtkRadioButton::_new_with_label(group, "button2");
  rbutton->set_active_ (TRUE);
  box2->pack_start_ (rbutton, TRUE, TRUE, 0)->show_ ();

  rbutton = GtkRadioButton::_new_with_label(gtk_radio_button_group(rbutton), "button3");
  box2->pack_start_ (rbutton, TRUE, TRUE, 0)->show_ ();

  separator = GtkHSeparator::_new ();
  box1->pack_start_ (separator, FALSE, TRUE, 0)->show_ ();

  box2 = GtkVBox::_new (FALSE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (box2), 10);
  gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, TRUE, 0);
  gtk_widget_show (box2);

  button = GtkButton::_new_with_label ("close");
  button->connect_object_ ("clicked", GTK_SIG close_application, window);
  box2->pack_start_ (button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  button->grab_default_ ();
  button->show_ ();
  window->show_ ();
   
  gtk_main();

  return(0);
}
/* example-end */

