#include <math.h>
#include <stdio.h>
#include <gtk/cc/gtk.h>
#include <gdk/cc/gdk.h>
#include <gtkextra/cc/gtkfontcombo.h>

#define PREVIEW_TEXT "ABCDEFGHI abcdefghi 0123456789"

void
quit ()
{
  gtk_main_quit();
}

void
new_font(GtkFontCombo *font_combo, GtkEntry* entry)
{
 GtkStyle *style = GtkStyle::_new ();
 gdk_font_unref (style->font);
 gdk_font_ref ((style->font = font_combo->font));

 entry->set_style_ (style);
 style->unref_ ();

 if (!strlen (entry->get_text_ ()))
   entry->set_text_(PREVIEW_TEXT);
 entry->set_position_ (0);

}

int main(int argc, char *argv[])
{
 GtkWindow *window1;
 GtkVBox *vbox1;
 GtkFontCombo *font_combo;
 GtkEntry *preview_entry;
 
 gtk_init(&argc,&argv);

 window1 = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);
 window1->set_title_ ("GtkPlot Demo");
 window1->set_border_width_ (0);

 window1->connect_ ("destroy", GTK_SIG quit, NULL);

 vbox1= GtkVBox::_new (FALSE,0);
 window1->add_ (vbox1)->show_ ();

 font_combo = GtkFontCombo::_new();
 vbox1->pack_start_ (font_combo, FALSE, FALSE, 0)->show_ ();

 preview_entry = GtkEntry::_new();
 vbox1->pack_start_ (preview_entry, TRUE, TRUE,0)->show_ ();
 preview_entry->set_text_ (PREVIEW_TEXT);
 window1->show_ ();

 new_font(font_combo, preview_entry); 
/*********** SIGNALS ************/
 font_combo->connect_ ("changed", GTK_SIG new_font, preview_entry);

 gtk_main();
 return(0);
}


