#include <math.h>
#include <stdio.h>
#include <gtk/cc/gtk.h>
#include <gtkextra/cc/gtkiconlist.h>
#include "icons.h"

void
clear(GtkIconList *icon_list, gpointer data)
{
  icon_list->clear_ ();
}

int main(int argc, char *argv[])
{
 GtkWindow *	window1;
 GtkNotebook *	notebook;
 GtkVBox *	vbox1;
 GtkHBox *	hbox1;
 GtkTable *	table;
 GtkScrolledWindow *	scrollw1;
 GtkScrolledWindow *	scrollw2;
 GtkIconList *	iconlist1;
 GtkIconList *	iconlist2;
 gchar label[10];
 gint i;
 
 gtk_init(&argc,&argv);

 window1 = GtkWindow::_new (GTK_WINDOW_TOPLEVEL);
 window1->set_title_ ("GtkIconList Demo");
 window1->set_usize_ (400,400);
 window1->set_border_width_ (0);

 window1->connect_ ("destroy", GTK_SIG gtk_main_quit, NULL);

 vbox1 = GtkVBox::_new(FALSE,0);
 window1->add_ (vbox1)->show_ ();

 hbox1 = GtkHBox::_new(FALSE,0);
 vbox1->pack_start_ (hbox1, TRUE, TRUE, 0)->show_ ();

 table = GtkTable::_new(4, 2, FALSE);
 hbox1->pack_start_ (table, FALSE, FALSE, 0)->show_ ();

 notebook = GtkNotebook::_new();
 hbox1->pack_start_(notebook, TRUE, TRUE,0)->show_ ();

 scrollw1 = GtkScrolledWindow::_new (NULL, NULL);
 scrollw1->set_border_width_ (0);
 scrollw1->set_policy_ (GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 notebook->append_page_ (scrollw1, (GtkLabel::_new ("Worksheets")))->show_ ();

 scrollw2 = GtkScrolledWindow::_new (NULL, NULL);
 scrollw2->set_border_width_ (0);
 scrollw2->set_policy_ (GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 notebook->append_page_ (scrollw2, (GtkLabel::_new ("Plots")))->show_ ();

 iconlist1 = GtkIconList::_new (48, 2);
 iconlist1->set_selection_mode_ (0);
 iconlist1->hadjustment->step_increment = 5;
 iconlist1->vadjustment->step_increment = 5;
 for(i=0; i<20; i++){
  sprintf(label,"Data %d",i); 
  iconlist1->add_from_data_ (sheet_icon2, label, NULL);
 }
 scrollw1->add_ (iconlist1)->show_ ();

 iconlist2 = GtkIconList::_new (48, 1);
 iconlist2->set_selection_mode_ (GTK_SELECTION_MULTIPLE);
 iconlist2->hadjustment->step_increment = 5;
 iconlist2->vadjustment->step_increment = 5;
 for(i=0; i<20; i++){
  sprintf(label,"Plot %d",i); 
  gtk_icon_list_add_from_data(GTK_ICON_LIST(iconlist2), plot_icon2, label, NULL);
 }
 scrollw2->add_ (iconlist2)->show_ ();

/*
 iconlist->connect_ ("button_press_event", clear, NULL);
*/

 window1->show_();
 gtk_main();

 return(0);
}


